import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopUser, ShopUserParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询用户记录表
 */
export async function pageShopUser(params: ShopUserParam) {
  const res = await request.get<ApiResult<PageResult<ShopUser>>>(
    MODULES_API_URL + '/shop/shop-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询用户记录表列表
 */
export async function listShopUser(params?: ShopUserParam) {
  const res = await request.get<ApiResult<ShopUser[]>>(
    MODULES_API_URL + '/shop/shop-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加用户记录表
 */
export async function addShopUser(data: ShopUser) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户记录表
 */
export async function updateShopUser(data: ShopUser) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除用户记录表
 */
export async function removeShopUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除用户记录表
 */
export async function removeBatchShopUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询用户记录表
 */
export async function getShopUser(id: number) {
  const res = await request.get<ApiResult<ShopUser>>(
    MODULES_API_URL + '/shop/shop-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
